unit UnitEvntMessage;
{
    Purpose:
        Over-narrowed class to write strings to the Eventlog
        as either an error or information only.
}
{///////////////}
{//}interface{//}
{///////////////}
uses Windows;

type TEventMessage = class(TObject)
private
    el : THandle;
public
    constructor Create(Source : string);
    destructor Destroy; override;
    procedure Log(StrMessage : string; error : boolean = false);
end;

{////////////////////}
{//}implementation{//}
{////////////////////}
constructor TEventMessage.Create(Source : string);
begin
    el := RegisterEventSource('',PChar(Source));
end;
destructor TEventMessage.Destroy;
begin
    DeregisterEventSource(el);

    inherited Destroy;
end;

procedure TEventMessage.Log(StrMessage : string; error : boolean = false);
var err : string;
    et : word;
begin
    err :=  StrMessage + chr(0);
    if (error) then begin
        et := EVENTLOG_ERROR_TYPE;
    end else begin
        et := EVENTLOG_INFORMATION_TYPE;
    end;
    Windows.ReportEvent(el,
        et,
        0,
        1,
        nil,
        1,
        0,
        @err,
        nil);
end;

end.
