unit UnitFormMain;
//
// Updates:
//      Added Halt exit codes for scripts
//
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Registry, StdCtrls;

type
  TFrmMain = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
        procedure RegistryForEventlog;
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

uses UnitRegSave, UnitEvntMessage;
{$R *.dfm}

{$R RDillyEventLog.res}
{all just to write to the eventlog without a long
drawn out BS message from NT}

procedure TFrmMain.RegistryForEventlog;
var r : TRegistry;
begin
    // register this program as the string table for the event log id
    r := TRegistry.Create;
    r.RootKey := HKEY_LOCAL_MACHINE;
    if not r.OpenKey('SYSTEM\CurrentControlSet\Services\EventLog\Application\RDilly', true) then
    begin
        ShowMessage('Can''t register program for EventLog');
        EXIT;
    end;
    r.WriteString('EventMessageFile', Application.EXEName);
    r.WriteInteger('TypesSupported',7);
    r.CloseKey;
    r.Free;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var foldername,
    path,
    cnt,
    finalfullname : string;

    i : integer;
    rs : TRegSave;

    EventMessage : TEventMessage;
begin
    // create a folder with the current date and a serial number for
    // backups done on the same day
    path := IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName));

    // TODO: add these options to an INI file
    DateTimeToString(foldername,'yy-mm-dd',date);
    foldername := 'registry__' + foldername;

    i := 0;
    repeat
        cnt := IntToSTr(i);
        while length(cnt) < 3 do begin
            cnt := '0' + cnt;
        end;
        inc(i);
    until not DirectoryExists(path + foldername + '__' + cnt);
    finalfullname := path + foldername + '__' + cnt;
    if Windows.SetPriorityClass(
        Windows.GetCurrentProcessId,
        IDLE_PRIORITY_CLASS) then begin
        ShowMessage('no worky');
    end;

    // damn EventLog
    self.RegistryForEventlog;

    // make sure the directory exists
    // save the registry
    // Bye Bye
    try
        EventMessage := TEventMessage.Create('RDilly');
        EventMessage.Log('Saving HKEY_LOCAL_MACHINE to folder ' + finalfullname);

        try
            rs := TRegSave.Create;
            ForceDirectories(finalfullname);
            rs.SaveRootToFolder(HKEY_LOCAL_MACHINE, finalfullname);

            EventMessage.Log('Program terminated normally');
        except
            on E: Exception do EventMessage.Log(E.Message, true);
            halt(1);
        end;
    finally
        halt(0);
        //Application.Terminate;

    end;
end;

end.
